﻿Namespace Tsql
    Public Class Keyword

        ''' <summary>Specifies the SQL <c>SELECT</c> keyword.</summary>
        Public Const [Select] As String = "SELECT "
        ''' <summary>Specifies the SQL <c>FROM</c> keyword.</summary>
        Public Const From As String = " FROM "
        ''' <summary>Specifies the SQL <c>WHERE</c> keyword.</summary>
        Public Const Where As String = " WHERE "
        ''' <summary>Specifies the SQL <c>AND</c> keyword.</summary>
        Public Const [And] As String = " AND "
        ''' <summary>Specifies the SQL <c>DISTINCT</c> keyword.</summary>
        Public Const Distinct As String = "DISTINCT "
        ''' <summary>Specifies the SQL character used to separate field names in a 
        ''' fields list keyword.</summary>
        Public Const FieldDelimiter As Char = ","c
        ''' <summary>Specifies the SQL character used to open a part of a conditional 
        ''' statement.</summary>
        Public Const OpenBrace As String = "("
        ''' <summary>Specifies the SQL character used to close a part of a conditional 
        ''' statement.</summary>
        Public Const CloseBrace As String = ")"
        ''' <summary>Specifies the SQL <c>AS</c> keyword.</summary>
        Public Const [As] As String = " AS "
        ''' <summary>Specifies the SQL character used to open quote field names.</summary>
        Public Const OpenQuote As Char = """"c
        ''' <summary>Specifies the SQL character used to close quote field names.</summary>
        Public Const CloseQuote As Char = """"c
        ''' <summary>Specifies the SQL used to quote field values.</summary>
        Public Const ValueQuote As Char = "'"c
        ''' <summary>Specifies the SQL <c>ASC</c> keyword.</summary>
        Public Const Asc As String = " ASC"
        ''' <summary>Specifies the SQL <c>DESC</c> keyword.</summary>
        Public Const Desc As String = " DESC"
        ''' <summary>Specifies the SQL <c>ORDER BY</c> keyword.</summary>
        Public Const OrderBy As String = " ORDER BY "
        ''' <summary>Specifies the SQL <c>BETWEEN</c> keyword.</summary>
        Public Const Between As String = " BETWEEN "
        ''' <summary>Specifies the SQL <c>OR</c> keyword.</summary>
        Public Const [Or] As String = " OR "
        ''' <summary>Specifies the SQL <c>TOP</c> keyword.</summary>
        Public Const Top As String = "TOP "
        ''' <summary>Specifies the SQL <c>INSERT</c> keyword.</summary>
        Public Const Insert As String = "INSERT "
        ''' <summary>Specifies the SQL character used to separate statements.
        ''' </summary>
        Public Const StatementDelimiter As Char = ";"c
        ''' <summary>Specifies the SQL <c>CREATE</c> keyword.</summary>
        Public Const Create As String = "CREATE "
        ''' <summary>Specifies the SQL <c>TABLE</c> keyword.</summary>
        Public Const Table As String = "TABLE "
        ''' <summary>Specifies the SQL equals charcter.</summary>
        Public Const EqualTo As Char = "="c
        ''' <summary>Specifies the SQL <c>JOIN</c> keyword.</summary>
        Public Const Join As String = " JOIN "
        ''' <summary>Specifies the SQL <c>ON</c> keyword.</summary>
        Public Const [On] As String = " ON "
        ''' <summary>Specifies the SQL <c>ON</c> keyword.</summary>
        Public Const [Off] As String = " OFF "
        ''' <summary>Specifies the SQL <c>SET</c> keyword.</summary>
        Public Const [Set] As String = "SET "
        ''' <summary>Specifies the SQL <c>ROWCOUNT</c> keyword.</summary>
        Public Const RowCount As String = "ROWCOUNT "
        ''' <summary>Specifies the SQL <c>NUMERIC</c> keyword.</summary>
        Public Const Numeric As String = "NUMERIC"
        ''' <summary>Specifies the SQL <c>CHAR</c> keyword.</summary>
        Public Const [Char] As String = "CHAR"
        ''' <summary>Specifies the SQL <c>VARCHAR</c> keyword.</summary>
        Public Const VarChar As String = "VARCHAR"
        ''' <summary>Specifies the SQL <c>COLLATE</c> keyword.</summary>
        Public Const Collate As String = " COLLATE "
        ''' <summary>Specifies the SQL <c>TEXT</c> keyword.</summary>
        Public Const Text As String = "TEXT"
        ''' <summary>Specifies the SQL <c>GROUP BY</c> keyword.</summary>
        Public Const GroupBy As String = " GROUP BY "
        ''' <summary>Specifies the SQL <c>LIKE</c> keyword.</summary>
        Public Const [Like] As String = " LIKE "
        ''' <summary>Specifies the SQL <c>IN</c> keyword.</summary>
        Public Const [In] As String = " IN "
        ''' <summary>Specifies the SQL <c>NOT</c> keyword.</summary>
        Public Const [Not] As String = "NOT "
    End Class
End Namespace

