﻿#Region " Imports "
Imports Infragistics.Web.UI.GridControls
Imports Data.Tsql
Imports System.Web.UI.WebControls

#End Region
<Serializable()>
Public Class GridColumn
    Private _column As String
    Private _columnHeaderText As String
    Private _columnTooltip As String
    Private _columnWidth As Integer
    Private _hidden As Boolean
    Private _columnVisibleIndex As Integer
    Private _dataType As String

#Region " Constants "
    Private Const HIDDEN_PREFIX As String = "Hidden "
#End Region

#Region " Declaration "
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub New(ByVal strColumn As String)
        Me._column = strColumn.Replace("""", String.Empty)
    End Sub

    Public Sub New(ByVal column As GridField)
        Me._column = column.Key
        Me._columnHeaderText = column.Header.Text
        Me._columnTooltip = column.Header.Tooltip
        Me._columnWidth = CInt(column.Width.Value)
        Me._hidden = column.Hidden
        Me._columnVisibleIndex = column.VisibleIndex
        Me._dataType = column.Type.FullName
    End Sub

    Public Sub New(ByVal column As GridGroupedColumn)
        Me._column = column.Column
    End Sub

    Public Sub New(ByVal column As String, ByVal columnWidth As Integer, ByVal columnHeaderText As String, _
                   ByVal columnHeaderTooltip As String, ByVal columnHidden As Boolean, ByVal columnVisibleIndex As Integer, _
                   ByVal columnDataType As String)
        Me._column = column
        Me._columnHeaderText = columnHeaderText
        Me._columnTooltip = columnHeaderTooltip
        Me._columnWidth = columnWidth
        Me._hidden = columnHidden
        Me._columnVisibleIndex = columnVisibleIndex
        Me._dataType = columnDataType
    End Sub
#End Region

#Region " Properties "
    Public Property Column() As String
        Get
            Return Me._column
        End Get
        Set(value As String)
            Me._column = value
        End Set
    End Property

    Public Property ColumnHeaderText() As String
        Get
            Return Me._columnHeaderText
        End Get
        Set(value As String)
            Me._columnHeaderText = value
        End Set
    End Property

    Public Property ColumnHeaderTooltip() As String
        Get
            Return Me._columnTooltip
        End Get
        Set(value As String)
            Me._columnTooltip = value
        End Set
    End Property

    Public Property ColumnWidth() As Integer
        Get
            Return Me._columnWidth
        End Get
        Set(value As Integer)
            Me._columnWidth = value
        End Set
    End Property

    Public Property Hidden() As Boolean
        Get
            Return Me._hidden
        End Get
        Set(value As Boolean)
            Me._hidden = value
        End Set
    End Property

    Public Property VisibleIndex() As Integer
        Get
            Return Me._columnVisibleIndex
        End Get
        Set(value As Integer)
            Me._columnVisibleIndex = value
        End Set
    End Property

    Public Property ColumnDataType() As String
        Get
            Return Me._dataType
        End Get
        Set(value As String)
            Me._dataType = value
        End Set
    End Property
#End Region
End Class
