﻿Imports System.ComponentModel
Imports System.Globalization
Imports System.Resources

Public Class GridPagerPageSizeChangedEventArgs
    Inherits EventArgs

#Region " Declarations "
    Private _newPageSize As Integer
#End Region

#Region " Constructors "
    ''' <summary>
    ''' Initializes a new instance of the <c>PageIndexChangeEventArgs</c> class.
    ''' </summary>
    ''' <param name="nNewPageSize">An <c>Integer</c>, the index of the new selected 
    ''' page.</param>
    Public Sub New(ByVal nNewPageSize As Integer)
        MyBase.New()
        Me.NewPageSize = nNewPageSize
    End Sub
#End Region

#Region " Properties "
    ''' <summary>
    ''' Gets or sets the index of the new selected page.
    ''' </summary>
    ''' <returns>An <c>Integer</c>.</returns>
    Public Property NewPageSize() As Integer
        Get
            Return _newPageSize
        End Get
        Set(ByVal New_NewPageSize As Integer)
            _newPageSize = New_NewPageSize
        End Set
    End Property
#End Region
End Class
